/*
 * ManipulateAtomsProcess.cpp
 *
 *  Created on: Feb 18, 2010
 *      Author: crueger
 */

#include "ManipulateAtomsProcess.hpp"

#include <iostream>

using namespace std;

ManipulateAtomsProcess::ManipulateAtomsProcess(boost::function<void(atom*)> _operation, AtomDescriptor _descr,
                                               std::string _name,bool _doRegister) :
  operation(_operation),
  descr(_descr),
  Process(0,_name,_doRegister)
{}

ManipulateAtomsProcess::~ManipulateAtomsProcess()
{}

void ManipulateAtomsProcess::call(){
  World* world = World::get();
  setMaxSteps(world->numAtoms());
  start();
  World::AtomIterator iter;
  for(iter=world->getAtomIter(descr);iter!=world->atomEnd();++iter){
    setCurrStep(iter.getCount());
    operation(*iter);
  }
  stop();
}

void ManipulateAtomsProcess::undo(){

}

bool ManipulateAtomsProcess::canUndo(){
  return false;
}
